Index: /trunk/LMDZ.GENERIC/libf/phystd/interpolateH2H2.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/interpolateH2H2.F90	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/interpolateH2H2.F90	(revision 253)
@@ -0,0 +1,214 @@
+     subroutine interpolateH2H2(wn,temp,pres,abcoef,firstcall)
+      implicit none
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Calculates the H2-H2 CIA opacity, using a lookup table from
+!     Borysow (2002)
+!
+!     Authors
+!     -------
+!     R. Wordsworth (2009)
+!     
+!==================================================================
+
+#include "datafile.h"
+
+      ! input
+      double precision wn                 ! wavenumber             (cm^-1)
+      double precision temp               ! temperature            (Kelvin)
+      double precision pres               ! pressure               (Pascals)
+
+      ! output
+      double precision abcoef             ! absorption coefficient (m^-1)
+
+      integer nS,nT
+      parameter(nS=1649)
+!      parameter(nT=7)
+      parameter(nT=14)
+
+      double precision amagat
+      double precision wn_arr(nS)
+      double precision temp_arr(nT)
+      double precision abs_arr(nS,nT)
+      !double precision data_tmp(nT+1)
+      double precision data_tmp(nT/2+1)
+
+      integer k
+      logical firstcall
+
+      save wn_arr, temp_arr, abs_arr
+
+      character*100 dt_file
+      integer strlen,ios
+
+      amagat=(273.15/temp)*(pres/101325.0)
+
+      if(firstcall)then
+
+!     1.1 Open the ASCII files
+
+         ! cold
+         dt_file=datafile(1:LEN_TRIM(datafile))//'/H2H2_CIA_LT.dat'
+         open(33,file=dt_file,form='formatted',status='old',iostat=ios)
+         if (ios.ne.0) then        ! file not found
+            write(*,*) 'Error from interpolateH2H2.for'
+            write(*,*) 'Data file could not be found:'
+            write(*,*) dt_file
+            call abort
+         else
+            do k=1,nS
+               read(33,*) data_tmp
+               wn_arr(k)=data_tmp(1)
+               abs_arr(k,1:7)=data_tmp(2:8)
+            end do
+         endif
+         close(33)
+
+         ! hot
+         dt_file=datafile(1:LEN_TRIM(datafile))//'/H2H2_CIA_HT.dat'
+         open(34,file=dt_file,form='formatted',status='old',iostat=ios)
+         if (ios.ne.0) then        ! file not found
+            write(*,*) 'Error from interpolateH2H2.for'
+            write(*,*) 'Data file could not be found:'
+            write(*,*) dt_file
+            call abort
+         else
+            do k=1,nS
+               read(34,*) data_tmp
+               wn_arr(k)=data_tmp(1)
+               ! wn_arr is identical
+               abs_arr(k,8:14)=data_tmp(2:8)
+            end do
+         endif
+         close(34)
+
+         temp_arr(1)  = 60.
+         temp_arr(2)  = 100.
+         temp_arr(3)  = 150.
+         temp_arr(4)  = 200.
+         temp_arr(5)  = 250.
+         temp_arr(6)  = 300.
+         temp_arr(7)  = 350.
+         temp_arr(8)  = 400.
+         temp_arr(9)  = 500.
+         temp_arr(10) = 600.
+         temp_arr(11) = 700.
+         temp_arr(12) = 800.
+         temp_arr(13) = 900.
+         temp_arr(14) = 1000.
+
+
+         print*,'At wavenumber ',wn,' cm^-1'
+         print*,'   temperature ',temp,' K'
+         print*,'   pressure ',pres,' Pa'
+
+         call bilinear(wn_arr,temp_arr,nS,nT,abs_arr,wn,temp,abcoef)
+
+         print*,'the absorption is ',abcoef,' cm^-1 amg^-2'
+
+         abcoef=abcoef*100.0*amagat**2 ! convert to m^-1
+
+         print*,'We have ',amagat,' amagats'
+         print*,'So the absorption is ',abcoef,' m^-1'
+
+      else
+  
+         call bilinear(wn_arr,temp_arr,nS,nT,abs_arr,wn,temp,abcoef)
+         abcoef=abcoef*100.0*amagat**2 ! convert to m^-1
+         !print*,'The absorption is ',abcoef,' m^-1'
+
+         ! unlike for Rayleigh scattering, we do not currently weight by the BB function
+         ! however our bands are normally thin, so this is no big deal.
+
+      endif
+
+      return
+    end subroutine interpolateH2H2
+
+
+
+! put as separate file eventually
+
+!-------------------------------------------------------------------------
+      subroutine bilinear(x_arr,y_arr,nX,nY,f2d_arr,x_in,y_in,f)
+!     Necessary for interpolation of continuum data
+
+      implicit none
+
+      integer nX,nY,i,j,a,b
+
+      real*8 x_in,y_in,x,y,x1,x2,y1,y2
+      real*8 f,f11,f12,f21,f22,fA,fB
+      real*8 x_arr(nX)
+      real*8 y_arr(nY)
+      real*8 f2d_arr(nX,nY)
+      
+      integer strlen
+      character*100 label
+      label='subroutine bilinear'
+
+      x=x_in
+      y=y_in
+
+!     1st check we're within the wavenumber range
+      if ((x.lt.x_arr(2)).or.(x.gt.x_arr(nX-2))) then
+         f=0.0D+0
+         return
+      else
+         
+!     in the x (wavenumber) direction 1st
+         i=1
+ 10      if (i.lt.(nX+1)) then
+            if (x_arr(i).gt.x) then
+               x1=x_arr(i-1)
+               x2=x_arr(i)
+               a=i-1
+               i=9999
+            endif
+            i=i+1
+            goto 10
+         endif
+      endif
+      
+      if ((y.lt.y_arr(1)).or.(y.gt.y_arr(nY))) then
+         write(*,*) 'Warning from bilinear.for:'
+         write(*,*) 'Extrapolating outside H2-H2 CIA temperature range!'
+         if(y.lt.y_arr(1))then
+            y=y_arr(1)+0.01
+         endif
+         if(y.gt.y_arr(nY))then
+            y=y_arr(nY)-0.01
+         endif
+      else
+
+!     in the y (temperature) direction 2nd
+         j=1
+ 20      if (j.lt.(nY+1)) then
+            if (y_arr(j).gt.y) then
+               y1=y_arr(j-1)
+               y2=y_arr(j)
+               b=j-1
+               j=9999
+            endif
+            j=j+1
+            goto 20
+         endif
+      endif
+      
+      f11=f2d_arr(a,b)
+      f21=f2d_arr(a+1,b)
+      f12=f2d_arr(a,b+1)
+      f22=f2d_arr(a+1,b+1)
+      
+!     1st in x-direction
+      fA=f11*(x2-x)/(x2-x1)+f21*(x-x1)/(x2-x1)
+      fB=f12*(x2-x)/(x2-x1)+f22*(x-x1)/(x2-x1)
+      
+!     then in y-direction
+      f=fA*(y2-y)/(y2-y1)+fB*(y-y1)/(y2-y1)
+      
+      return
+    end subroutine bilinear
Index: /trunk/LMDZ.GENERIC/libf/phystd/kastprof_fn.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/kastprof_fn.F90	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/kastprof_fn.F90	(revision 253)
@@ -0,0 +1,142 @@
+      subroutine kastprof_fn(tsurf,temp,popsk,play,plev,qvap)
+      implicit none
+
+!     creates a kasting temperature profile
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+#include "callkeys.h"
+
+      REAL play(nlayermx)   ! Pressure at the middle of the layers (Pa)
+      REAL plev(nlayermx+1) ! intermediate pressure levels (pa)
+      REAL psurf,tsurf      
+      REAL tcond(nlayermx)
+      REAL qvap(nlayermx)
+      REAL temp(nlayermx)   ! temperature at the middle of the layers
+
+      real, parameter :: Rstar   = 8.314
+      real, parameter :: ptriple = 518000.0
+      real, parameter :: latcond = 5.9e5     ! as in condense_co2
+      real, parameter :: mn      = 0.02801   ! molar mass of background gas (N2)
+      real, parameter :: mv      = 0.04401   ! molar mass of background gas (CO2)
+
+      real popsk(nlayermx)  ! this is dodgy as in rest of code, zpopsk(ngridmx,nlayermx)
+                            ! but kastprof requires 1D, so its ok I guess
+
+      real ppco2
+      real vmr_local,q_local,gamma,dqdlnT,dlnqdlnT,dlnpdlnT,dpdT,dln_p
+
+      integer l,iter
+
+      logical co2mixedcond
+
+      co2mixedcond=.true.
+
+      if(ngridmx.gt.1)then
+         print*,'DO NOT RUN KASTPROF IN 3D!!!'
+         call abort
+      end if
+
+      ! 1st, we make pot. temperature constant everywhere
+      do l=1,nlayermx
+            temp(l)=TsurfK*popsk(l)
+      enddo
+
+!     then do all the other stuff
+      vmr_local = 1.-n2mixratio
+      q_local   = vmr_local*mv/mn
+
+      qvap(1)   = q_local
+
+      ppco2=vmr_local*play(1)
+
+      if(play(1).lt.ptriple)then !
+         tcond(1) = (-3167.8)/(log(.01*ppco2)-23.23)         ! Fanale's formula
+      else
+         tcond(1) = 684.2-92.3*log(ppco2)+4.32*log(ppco2)**2 ! liquid-vapour (CRC handbook 2003 data)
+      endif
+
+      do l=1,nlayermx-1
+
+         ppco2=vmr_local*play(l) ! this shld be implicit i.e. vmr_local(l+1) ??
+
+         if(play(l).le.ptriple)then ! ERROR
+            tcond(l) = (-3167.8)/(log(.01*ppco2)-23.23)         ! Fanale's formula
+         else
+            tcond(l) = 684.2-92.3*log(ppco2)+4.32*log(ppco2)**2 ! liquid-vapour (CRC handbook 2003 data)
+         endif
+
+         if(co2mixedcond)then
+            if (temp(l) .le. Tstrat)then
+               temp(l)  = Tstrat            ! isothermal stratosphere
+               temp(l+1) = Tstrat
+               qvap(l+1) = qvap(l)
+               !print*,'strato'
+
+            elseif(temp(l) .le. tcond(l))then
+
+               dln_p     = log(play(l+1))-log(play(l))
+               gamma     = cpp - q_local*latcond/temp(l)
+               dqdlnT    = (mv*latcond/(mn*temp(l)) - gamma) & 
+                            / (latcond/temp(l) + Rstar/(mn*q_local))
+               dlnqdlnT  = (1./q_local)*dqdlnT
+               dlnpdlnT  = mv*latcond/(Rstar*temp(l)) - dlnqdlnT/(1. + q_local*mn/mv)
+               dpdT      = (play(l)/temp(l))*dlnpdlnT
+               q_local   = q_local + dqdlnT*dln_p/dlnpdlnT
+
+               vmr_local = q_local*mn/mv
+
+
+               if(1.eq.1)then
+               print*,'l         =',l
+               print*,'gamma     =',gamma
+               print*,'gamma bit =',q_local*latcond/temp(l)
+               print*,'cpp       =',cpp
+               print*,'latcond   =',latcond
+               print*,'q_local   =',q_local
+               print*,'T         =',temp(l)
+               print*,'p         =',play(l)
+               print*,'dqdlnT    =',dqdlnT
+               print*,'dlnqdlnT  =',dlnqdlnT
+               print*,'dlnpdlnT  =',dlnpdlnT
+               print*,'dpdT      =',dpdT
+               call abort
+               endif
+
+               qvap(l+1) = q_local
+               temp(l+1) = temp(l) + temp(l)*dln_p/(dlnpdlnT)
+               !print*,'CO2co'
+            else
+               !print*,'tropo'
+
+
+               ! CO2 is not condensing; therefore dry convection
+               qvap(l+1) = qvap(l)
+            endif
+
+         else
+
+            if (temp(l) .le. Tstrat)then
+               temp(l) = Tstrat            
+               ! isothermal stratosphere
+            elseif(temp(l) .le. tcond(l))then
+               temp(l)=tcond(l)
+               ! pure CO2 condensation
+            else
+               ! CO2 is not condensing; therefore dry convection 
+            endif
+
+         endif
+
+      enddo ! vertical loop
+
+      temp(nlayermx) = Tstrat
+      qvap(nlayermx) = qvap(nlayermx-1)
+
+      print*,'---fin---'
+
+      call abort
+
+      return
+    end subroutine kastprof_fn
Index: /trunk/LMDZ.GENERIC/libf/phystd/largescale.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/largescale.F	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/largescale.F	(revision 253)
@@ -0,0 +1,140 @@
+      subroutine largescale(dtime, paprs, pplay, t, pq,
+     &                   pdt, d_t, d_q, d_ql, rneb, reffH2O)
+
+      use watercommon_h, only : RLVTT, RCPD, RVTMP2
+
+      IMPLICIT none
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Calculates large-scale (stratiform) H2O condensation.
+!     
+!     Authors
+!     -------
+!     Adapted from the LMDTERRE code by R. Wordsworth (2009)
+!     Original author Z. X. Li (1993)
+!     
+!==================================================================
+
+#include "dimensions.h" 
+#include "dimphys.h"
+#include "comcstfi.h"
+
+#include "fisice.h"
+#include "callkeys.h"
+#include "tracer.h"
+
+
+!     Pre-arguments (for universal model)
+      real pq(ngridmx,nlayermx,nqmx)       ! tracer (kg/kg)
+
+!     Arguments
+      REAL dtime                     ! intervalle du temps (s)
+      REAL paprs(ngridmx,nlayermx+1) ! pression a inter-couche
+      REAL pplay(ngridmx,nlayermx)   ! pression au milieu de couche
+      REAL t(ngridmx,nlayermx)       ! temperature (K)
+      REAL q(ngridmx,nlayermx)       ! humidite specifique (kg/kg)
+      REAL d_t(ngridmx,nlayermx)     ! incrementation de la temperature (K)
+      REAL d_q(ngridmx,nlayermx)     ! incrementation de la vapeur d'eau
+      REAL d_ql(ngridmx,nlayermx)    ! incrementation de l'eau liquide
+      REAL rneb(ngridmx,nlayermx)    ! fraction nuageuse
+      REAL reffH2O(ngridmx,nlayermx) ! cloud particle mean radius (m)
+
+      REAL pdt(ngridmx,nlayermx) ! added by Benjamin!
+
+!     Options du programme
+      REAL ratqs   ! determine largeur de la distribution de vapeur
+      PARAMETER (ratqs=0.2)
+
+!     Variables locales
+      REAL CBRT
+      EXTERNAL CBRT
+      INTEGER i, k
+      REAL zt(ngridmx), zq(ngridmx)
+      REAL zcond(ngridmx)
+      REAL zdelq(ngridmx)
+      REAL zqs(ngridmx), zdqs(ngridmx)
+
+      REAL zcor(ngridmx), zdelta(ngridmx), zcvm5(ngridmx)
+      REAL zx_q(ngridmx)
+
+!     GCM -----> subroutine variables, initialisation of outputs
+      DO k = 1, nlayermx
+      DO i = 1, ngridmx
+         q(i,k)    = pq(i,k,igcm_h2o_vap)
+         d_t(i,k)  = 0.0
+         d_q(i,k)  = 0.0
+         d_ql(i,k) = 0.0
+         rneb(i,k) = 0.0
+      ENDDO
+      ENDDO
+
+!     Boucle verticale (du haut vers le bas)
+      DO 9999 k = nlayermx, 1, -1
+
+      DO i = 1, ngridmx
+         zt(i)=t(i,k)+pdt(i,k)*dtime
+         zq(i)=q(i,k) ! no need to add tendency as we're already dealing with qevap
+      ENDDO
+
+!     Calculer la vapeur d'eau saturante et 
+!     determiner la condensation partielle
+      DO i = 1, ngridmx
+
+         call watersat(zt(i),pplay(i,k),zqs(i))
+         call watersat_grad(zt(i),zqs(i),zdqs(i))
+
+         !IF (zt(i).LT.t_coup) THEN
+         !   zqs(i) = qsats(zt(i))/pplay(i,k)
+         !   zdqs(i) = dqsats(zt(i),zqs(i))
+         !ELSE
+         !   zqs(i) = qsatl(zt(i))/pplay(i,k)
+         !   zdqs(i) = dqsatl(zt(i),zqs(i))
+         !ENDIF
+
+         zdelq(i) = ratqs * zq(i)
+         rneb(i,k) = (zq(i)+zdelq(i)-zqs(i)) / (2.0*zdelq(i))
+         zcond(i) = 0.0
+         zx_q(i) = (zq(i)+zdelq(i)+zqs(i))/2.0
+         if (rneb(i,k) .LE. 0.0) zx_q(i) = 0.0
+         if (rneb(i,k) .GE. 1.0) zx_q(i) = zq(i)
+         rneb(i,k) = MAX(0.0,MIN(1.0,rneb(i,k)))
+         !zcond(i) = MAX(0.0,(zx_q(i)-zqs(i)*rneb(i,k)/(1.+zdqs(i))))
+         zcond(i) = MAX(0.0,(zx_q(i)-zqs(i))*rneb(i,k)/(1.+zdqs(i)))
+!     zcond always postive! cannot evaporate clouds!
+!     this is why we must reevaporate before largescale
+
+
+         zcond(i) = zcond(i)/dtime ! added by RDW
+
+!     for varying particle size in rad tran and (possibly) sedimentation
+         if(.not.aerofixed)then
+            reffH2O(i,k) = CBRT( 3*zcond(i)/( 4*Nmix_h2o*pi*rho_ice))
+            reffH2O(i,k) = max(reffH2O(i,k),1.e-8)
+         endif
+
+      ENDDO
+
+!     Tendances de t et q
+      DO i = 1, ngridmx
+         d_q(i,k)  = - zcond(i)
+         d_ql(i,k) = zcond(i)
+         !d_t(i,k) = zcond(i)*RLVTT/cpp
+         d_t(i,k)  = zcond(i)*RLVTT/RCPD!/(1.0+RVTMP2*q(i,k))
+         ! this one is FAR TOO BIG
+      ENDDO
+
+ 9999 CONTINUE
+
+      !print*,'qsat=',zqs
+      !print*,'q=',q
+      !print*,'dq=',d_q*dtime
+      !print*,'dT in LS=',d_t*dtime
+
+      !print*,'rice=',rice
+      !print*,'rneb=',rneb
+
+      return
+      end
Index: /trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/moistadj.F90	(revision 253)
@@ -1,3 +1,3 @@
-      subroutine moistadj(t, pq, pplev, pplay, dtmana, dqmana, ptimestep, rneb)
+subroutine moistadj(t, pq, pplev, pplay, dtmana, dqmana, ptimestep, rneb)
 
   use watercommon_h, only: To, RLVTT, RCPD
@@ -109,12 +109,13 @@
 
       DO k = 1, nlayermx
-      DO i = 1, ngridmx
-         local_q(i,k) = q(i,k)
-         local_t(i,k) = t(i,k)
-         rneb(i,k) = 0.0
-         d_ql(i,k) = 0.0
-         d_t(i,k)  = 0.0
-         d_q(i,k)  = 0.0
-      ENDDO
+         DO i = 1, ngridmx
+            local_q(i,k) = q(i,k)
+            local_t(i,k) = t(i,k)
+            rneb(i,k) = 0.0
+            d_ql(i,k) = 0.0
+            d_t(i,k)  = 0.0
+            d_q(i,k)  = 0.0
+         ENDDO
+         new_qb(k)=0.0
       ENDDO
 
@@ -132,5 +133,5 @@
             v_p = pplay(i,k)
 
-            call watersat_2(v_t,v_p,v_qs(i,k))
+            call watersat(v_t,v_p,v_qs(i,k))
             call watersat_grad(v_t,v_qs(i,k),v_qsd(i,k))
          ENDDO
@@ -141,5 +142,5 @@
 !         DO i = 1, ngridmx
 !            v_t = local_t(i,k)
-!            IF (v_t.LT.t_coup) THEN
+!            IF (v_t.LT.To) THEN
 !               print*,'RHs=',q(i,k) / v_qs(i,k)
 !            ELSE
@@ -223,5 +224,11 @@
          local_q(i,k) = new_qb(k)
          local_t(i,k) = cp_new_t(k) / RCPD
-      ENDDO
+
+!          print*,'v_qs in loop=',v_qs
+!          print*,'v_qsd in loop=',v_qsd
+!          print*,'new_qb in loop=',new_qb
+!          print*,'cp_delta_t in loop=',cp_delta_t
+      ENDDO
+
 
 !--------------------------------------------------- sounding downwards
@@ -242,5 +249,5 @@
 !           ENDIF
 
-         call watersat_2(v_t,v_p,v_qs(i,k))
+         call watersat(v_t,v_p,v_qs(i,k))
          call watersat_grad(v_t,v_qs(i,k),v_qsd(i,k))
 
@@ -332,4 +339,6 @@
       ENDDO
 
+!      print*,'local_q BEFORE=',local_q
+
       DO k = 1, nlayermx
       DO i = 1, ngridmx
@@ -361,8 +370,17 @@
 !      print*,'d_t=',d_t
 !      print*,'d_q=',d_q
+!      print*,'local_q=',local_q
+!      print*,'q=',q
+!      print*,'v_qs(i,k)=',v_qs
+!      print*,'v_qsd(i,k)=',v_qsd
+!      print*,'cp_delta_t(k)=',cp_delta_t
+
 !      print*,'d_ql=',d_ql
-!      print*,'i_h2o=',i_h2o
+!      print*,'delta_q=',delta_q
+!      print*,'zq1=',zq1
+!      print*,'zq2=',zq2
+!!      print*,'i_h2o=',i_h2o
 !      print*,'i_ice=',i_ice
-
+!
 !      print*,'IN MANABE:'
 !      print*,'d_q=',d_q
@@ -374,28 +392,28 @@
 
 !     Some conservation diagnostics...
-      dEtot=0.0
-      dL1tot=0.0
-      dL2tot=0.0
-      dqtot=0.0
-      masse=0.0
-      DO k = 1, nlayermx
-         DO i = 1, ngridmx
-
-            masse = (pplev(i,k) - pplev(i,k+1))/g
-
-            dEtot  = dEtot  + cpp*d_t(i,k)*masse
-            dL1tot = dL1tot + RLVTT*d_ql(i,k)*masse
-            dL2tot = dL2tot + RLVTT*d_q(i,k)*masse ! is this line necessary?
-
-            dqtot = dqtot + (d_q(i,k) + d_ql(i,k))*masse
-
-         ENDDO
-      ENDDO
-
-        print*,'In manabe energy change=',dEtot
-        print*,'In manabe condense energy change 1 =',dL1tot
-        print*,'In manabe condense energy change 2 =',dL2tot
-        print*,'In manabe water change=',dqtot
+!      dEtot=0.0
+!      dL1tot=0.0
+!      dL2tot=0.0
+!      dqtot=0.0
+!      masse=0.0
+!      DO k = 1, nlayermx
+!         DO i = 1, ngridmx
+!
+!            masse = (pplev(i,k) - pplev(i,k+1))/g
+!
+!            dEtot  = dEtot  + cpp*d_t(i,k)*masse
+!            dL1tot = dL1tot + RLVTT*d_ql(i,k)*masse
+!            dL2tot = dL2tot + RLVTT*d_q(i,k)*masse ! is this line necessary?
+!
+!            dqtot = dqtot + (d_q(i,k) + d_ql(i,k))*masse
+!
+!         ENDDO
+!      ENDDO
+
+!        print*,'In manabe energy change=',dEtot
+!        print*,'In manabe condense energy change 1 =',dL1tot
+!        print*,'In manabe condense energy change 2 =',dL2tot
+!        print*,'In manabe water change=',dqtot
 
       RETURN
-      END
+   END
Index: /trunk/LMDZ.GENERIC/libf/phystd/newsedim.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/newsedim.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/newsedim.F	(revision 253)
@@ -12,14 +12,14 @@
 !==================================================================
 
-c-----------------------------------------------------------------------
-c   declarations:
-c   -------------
+!-----------------------------------------------------------------------
+!   declarations
+!   ------------
 
 #include "dimensions.h"
 #include "dimphys.h"
 #include "comcstfi.h"
-c
-c   arguments:
-c   ----------
+
+!   arguments
+!   ---------
 
       INTEGER ngrid,nlay,naersize
@@ -57,9 +57,9 @@
 c    Physical constant
 c    ~~~~~~~~~~~~~~~~~
-!      REAL visc, molrad
+      REAL visc, molrad
 c     Gas molecular viscosity (N.s.m-2)
-!      data visc/1.e-5/       ! CO2
+      data visc/1.e-5/       ! CO2
 c     Effective gas molecular radius (m)
-!      data molrad/2.2e-10/   ! CO2
+      data molrad/2.2e-10/   ! CO2
 
 c     local and saved variable
@@ -69,4 +69,7 @@
 c    ** un petit test de coherence
 c       --------------------------
+
+
+      !print*,'temporary fixed particle rad in newsedim!!'
 
       IF (firstcall) THEN
@@ -81,4 +84,5 @@
 
 
+
 !=======================================================================
 !     Preliminary calculations for sedimenation velocity
@@ -95,9 +99,7 @@
 c   (correction = 0.85 for irregular particles, 0.5 for disk shaped particles)
 c        a = a    * 0.85
+
+
       ENDIF
-
-
-
-
 
 c-----------------------------------------------------------------------
@@ -116,6 +118,19 @@
             else
               i=ngrid*(l-1)+ig
-              rfall=rd(i)
+              rfall=rd(i) ! how can this be correct!!?
             endif  
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! TEMPORARY MODIF BY RDW !!!!
+            !rfall=5.e-6
+            if(rfall.lt.1.e-7)then
+               rfall=1.e-7
+            endif
+            !if(rfall.gt.5.e-5)then
+            !   rfall=5.e-5
+            !endif
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
             vstokes(ig,l) = b * rho * rfall**2 *
      &      (1 + 1.333* ( a*pt(ig,l)/pplev(ig,l) )/rfall)
Index: /trunk/LMDZ.GENERIC/libf/phystd/newtrelax.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/newtrelax.F90	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/newtrelax.F90	(revision 253)
@@ -0,0 +1,128 @@
+subroutine newtrelax(mu0,sinlat,popsk,temp,pplay,pplev,dtrad,firstcall) 
+        
+  implicit none
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+#include "callkeys.h"
+#include "netcdf.inc"
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Alternative Newtonian radiative transfer scheme.
+!     
+!     Authors
+!     -------
+!     R. Wordsworth (2010)
+!     
+!==================================================================
+  
+  ! Input
+  real mu0(ngridmx)                    ! cosine of sun incident angle
+  real sinlat(ngridmx)                 ! sine of latitude
+  real temp(ngridmx,nlayermx)          ! temperature at each layer (K)
+  real pplay(ngridmx,nlayermx)         ! pressure at each layer (Pa)
+  real pplev(ngridmx,nlayermx+1)       ! pressure at each level (Pa)
+  real popsk(ngridmx,nlayermx)         ! pot. T to T converter
+
+  ! Output
+  real dtrad(ngridmx,nlayermx) 
+
+  ! Internal
+  real Trelax(ngridmx,nlayermx), Trelax_V, Trelax_H
+  save Trelax
+
+  real T_trop ! relaxation temperature at tropopause (K)
+  real T_surf ! relaxation temperature at surface (K)
+  real dT_EP  ! Equator-Pole relaxation temperature difference (K)
+
+  real sig, f_sig, sig_trop
+  integer l,ig
+  logical firstcall
+
+
+  logical tidallocked
+  parameter (tidallocked = .true.)
+
+  ! Setup relaxation temperature  
+  if(firstcall) then
+
+     print*,'-----------------------------------------------------'
+     print*,'| ATTENTION: You are using a Newtonian cooling scheme'
+     print*,'| for the radiative transfer. This means that ALL'
+     print*,'| other physics subroutines must be switched off.'
+     print*,'-----------------------------------------------------'
+
+     if(tidallocked)then
+        do ig=1,ngridmx
+
+           T_surf = 126. + 239.*mu0(ig)
+           T_trop = 140. + 52.*mu0(ig)
+           do l=1,nlayermx
+
+              if(mu0(ig).le.0.0)then ! night side
+                 Trelax(ig,l)=0.0
+              else                   ! day side
+                 Trelax(ig,l) = T_surf*popsk(ig,l)
+                 if (Trelax(ig,l).lt.T_trop) Trelax(ig,l) = T_trop
+              endif
+
+           enddo
+        enddo
+
+     else
+
+        T_trop = 200.
+        T_surf = 288.
+        dT_EP  = 70.
+
+        sig_trop=(T_trop/T_surf)**(1./rcp)
+
+        do l=1,nlayermx
+           do ig=1,ngridmx
+
+              ! vertically varying component
+              Trelax_V = T_surf*popsk(ig,l)
+              if (Trelax_V.lt.T_trop) Trelax_V = T_trop
+              
+              ! horizontally varying component
+              sig = pplay(ig,l)/pplev(ig,1)
+              if(sig.ge.sig_trop)then
+                 f_sig=sin((pi/2)*((sig-sig_trop)/(1-sig_trop)))
+              else
+                 f_sig=0.0
+              endif
+              Trelax_H = -f_sig*dT_EP*(sinlat(ig)**2 - 1./3.)
+              
+              Trelax(ig,l) = Trelax_V + Trelax_H            
+           
+           enddo
+        enddo
+
+     endif
+
+     firstcall=.false.
+ 
+  endif
+
+  ! Calculate radiative forcing
+  do l=1,nlayermx
+     do ig=1,ngridmx
+        dtrad(ig,l) = -(temp(ig,l) - Trelax(ig,l)) / tau_relax
+        if(temp(ig,l).gt.500.)then ! Trelax(ig,l))then
+           print*,'ig=',ig
+           print*,'l=',l
+           print*,'temp=',temp(ig,l)
+           print*,'Trelax=',Trelax(ig,l)
+        endif
+     enddo
+  enddo
+
+  call writediagfi(ngridmx,'Tref','rad forc temp','K',3,Trelax)
+  !call writediagfi(ngridmx,'ThetaZ','stellar zenith angle','deg',2,mu0)
+
+  return
+end subroutine newtrelax
